// **TODO** Improve this so I don't need to 
// run two copies to monitor two different ports
// Listens on 7800 or 7801


#include <stdio.h>
#include <string.h>

#if WIN32
	#include <winsock2.h>
#else
	#include <sys/socket.h>
	#include <netinet/in.h>
	#include <unistd.h>
	#define closesocket(socket) close(socket)
#endif

#include "SigsNetworkMessage.h"




int main()
{
	int serverListenSocket;
    int sock;
    struct sockaddr_in addr;
    char buffer[512];
    int readLen;
    int sourceLen;
    struct sockaddr_in source;
	int messageLength;


#ifdef WIN32
	WSADATA wsaData;

	printf("Initializing Winsock\n");
	if (WSAStartup(MAKEWORD(1, 1), &wsaData) != 0)
	{
		fprintf(stderr, "Error initializing Winsock\n");
		return -1;
	}
#endif


    // Open a socket
    printf("Opening a socket\n");
    serverListenSocket = socket(AF_INET, SOCK_STREAM, 0);
    if (serverListenSocket == -1)
    {
		fprintf(stderr, "Error opening socket\n");
		return 1;
    }

    // Set the listen address							** Change port **
    addr.sin_family = AF_INET;
    addr.sin_port = htons(7801);
    addr.sin_addr.s_addr = INADDR_ANY;

    // Bind the socket to a local address to listen on
    printf("Binding to server port\n");
    if (bind(serverListenSocket, (struct sockaddr*)&addr, sizeof(addr)) < 0)
    {
		closesocket(serverListenSocket);
		fprintf(stderr, "Could not bind to port\n");
		return 2;
    }


	// Listen for incomming connections
	printf("Listening for incomming connections...\n");
	if (listen(serverListenSocket, SOMAXCONN) == SOCKET_ERROR)	// or != 0
	{
		closesocket(serverListenSocket);
		fprintf(stderr, "Could not listen for incomming connections\n");
		return 3;
	}


	for ( ; ; )
	{
		// Accept incomming connections
		sock = accept(serverListenSocket, 0, 0);
		printf("\nNew connection accepted\n");


		// Prepare to receive network data
		// Receive data loop
		printf("Entering receive loop\n");
		for ( ; ; )
		{
			sourceLen = sizeof(source);
			readLen = recvfrom(sock, buffer, 512, 0, (struct sockaddr*)&source, &sourceLen);
			if (readLen > 0)
			{
				// Create a reference to the message header in the data
				MessageHeader &header = *(MessageHeader*)&buffer[4];

				// Display packet info
				cout << endl << "Received message" << endl;
				if (sourceLen > 0)
					printf("RecvFrom :%d (%d bytes) \n", source.sin_port, readLen);
				DumpHumanReadableMessage(cout, &buffer[4]);


				// Process each message type
				// *************************

				if (ntohl(header.messageType) == 616)	// SIGS Version Check
				{
					messageLength = FormatMessage(buffer, 512, 901, "127.0.0.1", 7800);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);
				}

				if (ntohl(header.messageType) == 626)	// Game Version Check
				{
					messageLength = FormatMessage(buffer, 512, 907, 0, 0, 0);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);
				}

				if (ntohl(header.messageType) == 620)	// New Member
				{
					messageLength = FormatMessage(buffer, 512, 302, 0, "", "");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);
				}


				if (ntohl(header.messageType) == 601)	// Login
				{
					// Accept the login attempt?
					// RoomServerConnectStatus
					// Note: "<Windows dir>\SOLcache\<name>??.dib" will be used to 
					//		load and display the logo on the top right. (Default of SIGS logo)
					//		It cycles through each image, displaying it for 1 minute each.
					messageLength = FormatMessage(buffer, 512, 101, "OUTPST", 0); 
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					// Change Gaming Profile
					messageLength = FormatMessage(buffer, 512, 109, "Hooman", "Hooman", 4, "Tag line", "Location");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					// Change Membership Profile
					messageLength = FormatMessage(buffer, 512, 314, "Hooman", "Real Name", "PASSWORD", "Addr1", "Addr2", "City", "State", "Country", "P2C", "Email Address", "Other", 1, 1, 1, 99, 9, 5, 3, 3, 9);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					// Inform client of available room servers
					messageLength = FormatMessage(buffer, 512, 306, "Room1", "Last One Standing", 1, 6, 0, 0, 0, "", "An Outpost channel", "127.0.0.1", 7801);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					// Inform client of available room servers
					messageLength = FormatMessage(buffer, 512, 306, "Another Room", "Last One Standing", 9, 6, 0, 0, 0, "", "Another channel", "127.0.0.1", 7801);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					// Inform client of available room servers
					messageLength = FormatMessage(buffer, 512, 306, "Outpost 2", "Last One Standing", 12, 6, 0, 0, 0, "", "Room3 Description", "127.0.0.1", 7801);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					/*
					// Message of the day
					messageLength = FormatMessage(buffer, 512, 803, 1, "Msg1", "Msg2");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);
					*/

					messageLength = FormatMessage(buffer, 512, 316, "String1", "String2", "String3", "String4", 0, 0, 0, 0, 0, 0, 0, 0);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);
				}


				if (ntohl(header.messageType) == 602)	// Room join request
				{
					// Join a room
					messageLength = FormatMessage(buffer, 512, 303, 0);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);
				}


				if (ntohl(header.messageType) == 603)	// Room create request
				{
					messageLength = FormatMessage(buffer, 512, 304, 0);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);
				}

				if (ntohl(header.messageType) == 111)	// Attempting room join
				{
					// Accept the room join
					messageLength = FormatMessage(buffer, 512, 401, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);


					// Setup room
					messageLength = FormatMessage(buffer, 512, 402, 0, 2);
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);


					// Tell client about users they can PM
					messageLength = FormatMessage(buffer, 512, 201, "User1");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					messageLength = FormatMessage(buffer, 512, 201, "User2");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					// Make the users greet the person joining
					messageLength = FormatMessage(buffer, 512, 701, "User1", "Hi");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					messageLength = FormatMessage(buffer, 512, 701, "User2", "Hello!");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);

					// Change Gaming Profile
					messageLength = FormatMessage(buffer, 512, 109, "User1", "User1", 4, "Tag line", "User 1 Location");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);
					// Change Gaming Profile
					messageLength = FormatMessage(buffer, 512, 109, "User2", "User2", 4, "Tag line", "USer 2 Location");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					SendMessage(sock, buffer);



					// Remove a user from the list
					messageLength = FormatMessage(buffer, 512, 202, "User2");
					if (messageLength == 0)
						printf("FormatMessage returned an error\n");
					//SendMessage(sock, buffer);
				}
			}
			else
			{
				printf("Connection closed\n");
				break;
			}
		}
	}


    // Close the socket and exit
    printf("Closing socket and exiting\n");
    closesocket(sock);
#ifdef WIN32
	WSACleanup();
#endif
    return 0;
}
