// This file contains a list of all possible messages that
// the SIGS system may send or receive.
// See SigsMessagesMetaData.h for a description of what each
// field means.


// Describes the format of the data in this file
#include "SigsMessagesMetaData.h"


// Array describing all message data formats used by SIGS
const MessageDataFormat dataFormat[] = 
{
	{ 1, 1,  { Buffer, EOL }},
	{ 2, 2,  { String, Buffer, EOL }},

	{ 101, 2,  { String, Int, EOL }},
	{ 102, 3,  { String, String, Int, EOL }},
	{ 103, 4,  { String, String, Int, Int, EOL }},
	{ 104, 1,  { String, EOL }},
	{ 105, 1,  { String, EOL }},
	{ 106, 1,  { String, EOL }},
	{ 107, 0,  { EOL }},
	{ 108, 3,  { String, Int, Int, EOL }},
	{ 109, 5,  { String, String, Char, String, String, EOL }},
	{ 110, 2,  { String, Int, EOL }},
	{ 111, 7,  { String, String, Char, String, String, String, Int, EOL }},

	{ 201, 1,  { String, EOL }},
	{ 202, 1,  { String, EOL }},
	{ 203, 1,  { Int, EOL }},
	{ 204, 1,  { Int, EOL }},
	{ 205, 3,  { String, String, Int, EOL }},
	{ 206, 1,  { String, EOL }},
	{ 207, 0,  { EOL }},
	{ 208, 3,  { String, String, Int, EOL }},
	{ 209, 21, { Int, Int, String, String, String, String, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, EOL }},

	{ 301, 1,  { Float, EOL }},
	{ 302, 3,  { Int, String, String, EOL }},
	{ 303, 1,  { Int, EOL }},
	{ 304, 1,  { Int, EOL }},
	{ 305, 1,  { Int, EOL }},
	{ 306, 11, { String, String, Int, Int, Int, Int, Char, String, String, String, Int, EOL }},
	{ 307, 3,  { String, String, Int, EOL }},
	{ 308, 1,  { Int, EOL }},
	{ 309, 1,  { String, EOL }},
	{ 310, 2,  { Int, Int, EOL }},
	{ 311, 2,  { Int, String, EOL }},
	{ 312, 2,  { Int, Int, EOL }},
	{ 313, 1,  { Int, EOL }},
	{ 314, 20, { String, String, String, String, String, String, String, String, String, String, String, Short, Short, Int, Char, Char, Char, Char, Char, Char, EOL }},
	{ 315, 2,  { Int, String, EOL }},
	{ 316, 12, { String, String, String, String, Short, Short, Char, Char, Char, Char, Char, Char, EOL }},
	{ 317, 0,  { EOL }},

	{ 401, 14, { Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, EOL }},
	{ 402, 2,  { Int, Int, EOL }},
	{ 403, 7,  { String, Int, Int, Int, Int, String, Int, EOL }},
	{ 404, 3,  { Int, String, Int, EOL }},
	{ 405, 1,  { String, EOL }},
	{ 406, 1,  { String, EOL }},
	{ 407, 4,  { String, Int, Int, String, EOL }},
	{ 408, 2,  { Int, String, EOL }},
	{ 409, 4,  { String, Int, Int, String, EOL }},
	{ 410, 1,  { Int, EOL }},
	{ 411, 4,  { String, Int, Int, String, EOL }},
	{ 412, 4,  { String, Int, Int, String, EOL }},
	{ 413, 1,  { Int, EOL }},
	{ 414, 3,  { Int, String, Buffer, EOL }},
	{ 415, 3,  { String, Int, Int, EOL }},
	{ 416, 2,  { String, String, EOL }},
	{ 417, 1,  { Int, EOL }},
	{ 418, 3,  { String, Int, String, EOL }},
	{ 419, 4,  { String, Int, Int, String, EOL }},
	{ 420, 4,  { String, Int, Int, String, EOL }},
	{ 421, 4,  { String, String, String, Int, EOL }},
	{ 422, 4,  { String, String, String, Int, EOL }},
	{ 423, 2,  { String, Int, EOL }},
	{ 424, 2,  { Int, Int, EOL }},

	{ 501, 0,  { EOL }},
	{ 502, 1,  { Int, EOL }},
	{ 503, 0,  { EOL }},
	{ 504, 0,  { EOL }},
	{ 505, 1,  { Buffer, EOL }},
	{ 506, 0,  { EOL }},

	{ 601, 2,  { String, String, EOL }},
	{ 602, 1,  { Int, EOL }},
	{ 603, 6,  { String, String, String, Int, Char, String, EOL }},
	{ 604, 0,  { EOL }},
	{ 605, 7,  { String, Int, Int, Int, Int, Int, Int, EOL }},
	{ 606, 4,  { String, Int, Int, String, EOL }},
	{ 607, 2,  { String, Int, EOL }},
	{ 608, 4,  { String, String, Int, Int, EOL }},
	{ 609, 2,  { String, Int, EOL }},
	{ 610, 3,  { String, Int, String, EOL }},
	{ 611, 2,  { String, Int, EOL }},
	{ 612, 1,  { String, EOL }},
	{ 613, 1,  { Short, EOL }},
	{ 614, 0,  { EOL }},
	{ 615, 0,  { EOL }},
	{ 616, 2,  { String, String, EOL }},
	{ 617, 0,  { EOL }},
	{ 618, 1,  { Int, EOL }},
	{ 619, 0,  { EOL }},
	{ 620, 21, { String, String, String, String, String, String, String, String, String, String, String, String, Short, Short, Int, Char, Char, Char, Char, Char, Char, EOL }},
	{ 621, 2,  { String, String, EOL }},
	{ 622, 23, { String, String, String, String, String, String, String, String, String, String, String, String, String, String, Short, Short, Int, Char, Char, Char, Char, Char, Char, EOL }},
	{ 623, 1,  { String, EOL }},
	{ 624, 2,  { String, String, EOL }},
	{ 625, 1,  { Buffer, EOL }},
	{ 626, 2,  { String, String, EOL }},
	{ 627, 3,  { String, Int, Int, EOL }},
	{ 628, 2,  { String, Int, EOL }},
	{ 629, 3,  { String, Int, Int, EOL }},
	{ 630, 4,  { String, Int, Int, String, EOL }},
	{ 631, 2,  { String, String, EOL }},
	{ 632, 1,  { String, EOL }},
	{ 633, 1,  { String, EOL }},
	{ 634, 1,  { String, EOL }},

	{ 701, 2,  { String, String, EOL }},
	{ 702, 3,  { String, String, String, EOL }},
	{ 703, 1,  { Buffer, EOL }},
	{ 704, 3,  { Int, Int, Buffer, EOL }},

	{ 801, 1,  { String, EOL }},
	{ 802, 2,  { String, String, EOL }},
	{ 803, 3,  { Int, String, String, EOL }},
	{ 804, 1,  { String, EOL }},

	{ 901, 2,  { String, Int, EOL }},
	{ 902, 0,  { EOL }},
	{ 903, 2,  { String, Int, EOL }},
	{ 904, 1,  { Int, EOL }},
	{ 905, 1,  { Buffer, EOL }},
	{ 906, 0,  { EOL }},
	{ 907, 3,  { Int, Int, Short, EOL }},
};


// Useful constants
const int numSigsMessages = sizeof(dataFormat)/sizeof(dataFormat[0]);
const int maxSigsMessageType = dataFormat[numSigsMessages-1].messageType;


// Returns a pointer to the meta data describing the message of
// the given type. If no meta data is found, a NULL pointer is returned
// Note: Uses binary search to locate the meta data
const MessageDataFormat * FindMessageDataFormat(int messageType)
{
	int start = 0;
	int end = numSigsMessages - 1;
	int current = (start + end) >> 1;

	do
	{
		// Check if the MessageDataType was found
		if (dataFormat[current].messageType == messageType)
			return &dataFormat[current];	// Return found MessageDataFormat

		// Determine which half of list to search
		if (dataFormat[current].messageType < messageType)
			start = current+1;
		if (dataFormat[current].messageType > messageType)
			end = current-1;

		// Determine index of next MessageDataFormat to check
		current = (start + end) >> 1;
	} while(start <= end);

	// The MessageDataFormat was not found
	return 0;
}

