// This meta data is used to describe each packet that the SIGS
// system may send or receive. 
// For a list of all possible messages, see SigsMessage.cpp.



// A structure used to describe the format of the SIGS messages
struct MessageDataFormat
{
	int messageType;				// SIGS message type
	int numDataFields;				// Number of data fields for this message type
	enum DataType dataTypes[24];	// Types of each data field (size of field implied by type)
};

// Possible data types used by the SIGS messages
enum DataType
{
	Word = 0,	// A 16-bit integer that doesn't need endian correction
	Int,		// A 32-bit Big Endian integer
	Float,		// A 4 byte floating point value
	Double,		// A 8 byte floating point value
	Short,		// A 16-bit Big Endian integer
	Dword,		// A 32-bit integer that doesn't need endian correction
	Char,		// Char data type
	String,		// Null terminated ASCII string
	Buffer,		// Length prefixed buffer

	EOL = -1	// End Of List
};
